curl --request PUT \
--url https://api.qovery.com/terraform/{terraformId} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "<string>",
"terraform_files_source": {},
"terraform_variables_source": {
"tf_var_file_paths": [
"<string>"
],
"tf_vars": [
{
"key": "<string>",
"value": "<string>",
"secret": true
}
]
},
"provider_version": {
"explicit_version": "<string>",
"read_from_terraform_block": true
},
"job_resources": {
"cpu_milli": 123,
"ram_mib": 123,
"gpu": 1,
"storage_gib": 123
},
"description": "",
"auto_deploy": true,
"auto_preview": true,
"backend": {
"kubernetes": {}
},
"timeout_sec": 123,
"icon_uri": "<string>",
"use_cluster_credentials": true,
"action_extra_arguments": {},
"dockerfile_fragment": {
"type": "file",
"path": "/infra/terraform/custom-build.dockerfile"
},
"blueprint_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"build_settings": {
"timeout_max_sec": 1800,
"cpu_max_in_milli": 4000,
"ram_max_in_gib": 8,
"ephemeral_storage_in_gib": null,
"disable_buildkit_cache": false,
"skip_git_submodules": false
}
}
'import requests
url = "https://api.qovery.com/terraform/{terraformId}"
payload = {
"name": "<string>",
"terraform_files_source": {},
"terraform_variables_source": {
"tf_var_file_paths": ["<string>"],
"tf_vars": [
{
"key": "<string>",
"value": "<string>",
"secret": True
}
]
},
"provider_version": {
"explicit_version": "<string>",
"read_from_terraform_block": True
},
"job_resources": {
"cpu_milli": 123,
"ram_mib": 123,
"gpu": 1,
"storage_gib": 123
},
"description": "",
"auto_deploy": True,
"auto_preview": True,
"backend": { "kubernetes": {} },
"timeout_sec": 123,
"icon_uri": "<string>",
"use_cluster_credentials": True,
"action_extra_arguments": {},
"dockerfile_fragment": {
"type": "file",
"path": "/infra/terraform/custom-build.dockerfile"
},
"blueprint_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"build_settings": {
"timeout_max_sec": 1800,
"cpu_max_in_milli": 4000,
"ram_max_in_gib": 8,
"ephemeral_storage_in_gib": None,
"disable_buildkit_cache": False,
"skip_git_submodules": False
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: '<string>',
terraform_files_source: {},
terraform_variables_source: {
tf_var_file_paths: ['<string>'],
tf_vars: [{key: '<string>', value: '<string>', secret: true}]
},
provider_version: {explicit_version: '<string>', read_from_terraform_block: true},
job_resources: {cpu_milli: 123, ram_mib: 123, gpu: 1, storage_gib: 123},
description: '',
auto_deploy: true,
auto_preview: true,
backend: {kubernetes: {}},
timeout_sec: 123,
icon_uri: '<string>',
use_cluster_credentials: true,
action_extra_arguments: {},
dockerfile_fragment: {type: 'file', path: '/infra/terraform/custom-build.dockerfile'},
blueprint_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
build_settings: {
timeout_max_sec: 1800,
cpu_max_in_milli: 4000,
ram_max_in_gib: 8,
ephemeral_storage_in_gib: null,
disable_buildkit_cache: false,
skip_git_submodules: false
}
})
};
fetch('https://api.qovery.com/terraform/{terraformId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"created_at": "2023-11-07T05:31:56Z",
"name": "<string>",
"timeout_sec": 600,
"auto_deploy": true,
"icon_uri": "<string>",
"service_type": "APPLICATION",
"terraform_variables_source": {
"tf_var_file_paths": [
"<string>"
],
"tf_vars": [
{
"key": "<string>",
"value": "<string>",
"secret": true
}
]
},
"engine": "TERRAFORM",
"backend": {
"kubernetes": {}
},
"provider_version": {
"explicit_version": "<string>",
"read_from_terraform_block": true
},
"job_resources": {
"cpu_milli": 123,
"ram_mib": 123,
"gpu": 1,
"storage_gib": 123
},
"environment": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
},
"use_cluster_credentials": true,
"action_extra_arguments": {},
"updated_at": "2023-11-07T05:31:56Z",
"warnings": [
{
"code": "GIT_WEBHOOK_PERMISSION_DENIED",
"message": "<string>"
}
],
"description": "<string>",
"auto_preview": true,
"build_settings_editable": true,
"auto_deploy_config": {
"auto_deploy": true,
"terraform_action": "DEFAULT"
},
"terraform_files_source": {
"git": {
"git_repository": {
"provider": "BITBUCKET",
"owner": "John Doe",
"url": "<string>",
"name": "simple-node-app",
"has_access": true,
"branch": "<string>",
"root_path": "<string>",
"deployed_commit_id": "<string>",
"deployed_commit_date": "2023-11-07T05:31:56Z",
"deployed_commit_contributor": "<string>",
"deployed_commit_tag": "v1.0.1",
"git_token_id": "<string>",
"git_token_name": "<string>"
}
}
},
"dockerfile_fragment": {
"type": "file",
"path": "/infra/terraform/custom-build.dockerfile"
},
"blueprint_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}Edit Terraform
Authorizations
JWT tokens should be used with OIDC account (human to machine). JWT tokens used by the Qovery console to communicate with the API have a TTL. Curl Example ' curl https://console.qovery.com/organization -H "Authorization: Bearer $qovery_token" '
Path Parameters
Terraform ID
Body
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Legacy alternative to auto_deploy_config.
Configuration for Terraform backend - exactly one backend type must be specified
- Option 1
- Option 2
- Option 3
Show child attributes
Show child attributes
TERRAFORM, OPEN_TOFU The key represent the action command name i.e: "plan" The value represent the extra arguments to pass to this command
i.e: {"apply", ["-lock=false"]} is going to prepend -lock=false to terraform apply commands
Show child attributes
Show child attributes
Custom Dockerfile fragment to inject during build. Optional field. When null, no custom fragment is injected.
- DockerfileFragmentFile
- DockerfileFragmentInline
Show child attributes
Show child attributes
The blueprint ID the service has been created from
Build configuration settings for the service. When sent, it replaces all six values entirely — omitted properties fall back to their defaults, not to the service's current values.
Show child attributes
Show child attributes
Response
Edit Terraform
A Terraform service
name is case insensitive
x >= 0Icon URI representing the terraform service.
type of the service (application, database, job, ...)
APPLICATION, DATABASE, CONTAINER, JOB, HELM, TERRAFORM, ARGOCD_APP, AGENTIC_WORKFLOW Show child attributes
Show child attributes
TERRAFORM, OPEN_TOFU Configuration for Terraform backend - exactly one backend type must be specified
- Option 1
- Option 2
- Option 3
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
The key represent the action command name i.e: "plan" The value represent the extra arguments to pass to this command
i.e: {"apply", ["-lock=false"]} is going to prepend -lock=false to terraform apply commands
Show child attributes
Show child attributes
Non-blocking problems found while applying a service edit. Only present on the response of an edit, and only when there is at least one warning. The edit itself is saved.
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Custom Dockerfile fragment to inject during build. When null, no custom fragment is injected.
- DockerfileFragmentFile
- DockerfileFragmentInline
Show child attributes
Show child attributes
The blueprint ID the service has been created from
Was this page helpful?